Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/OsmBase.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/OsmBase.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/OsmBase.cs	(revision 8516)
@@ -0,0 +1,24 @@
+﻿using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Problems.RoutePlanning.Data.Osm.Core {
+  public abstract class OsmBase {
+    public long Id { get; set; }
+    public string User { get; set; }
+    public int UserId { get; set; }
+    public DateTime Timestamp { get; set; }
+    public long Changeset { get; set; }
+    public int Version { get; set; }
+    public bool Visible { get; set; }
+    public IDictionary<string, string> Tags { get; set; }
+
+    public OsmBase() {
+      Tags = new Dictionary<string, string>();
+    }
+
+    public OsmBase(long id) {
+      Id = id;
+      Tags = new Dictionary<string, string>();
+    }
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/Relation.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/Relation.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/Relation.cs	(revision 8516)
@@ -0,0 +1,20 @@
+﻿
+using System.Collections.Generic;
+namespace HeuristicLab.Problems.RoutePlanning.Data.Osm.Core {
+  public class Relation : OsmBase {
+    private List<RelationMember> members;
+
+    public Relation() {
+      members = new List<RelationMember>();
+    }
+
+    public Relation(long id)
+      : base(id) {
+      members = new List<RelationMember>();
+    }
+
+    public List<RelationMember> Members {
+      get { return members; }
+    }
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/RelationMember.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/RelationMember.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/RelationMember.cs	(revision 8516)
@@ -0,0 +1,7 @@
+﻿
+namespace HeuristicLab.Problems.RoutePlanning.Data.Osm.Core {
+  public class RelationMember {
+    public OsmBase Member { get; set; }
+    public string Role { get; set; }
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/TagConstants.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/TagConstants.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/TagConstants.cs	(revision 8516)
@@ -0,0 +1,11 @@
+﻿
+namespace HeuristicLab.Problems.RoutePlanning.Data.Osm.Core {
+  public class TagConstants {
+    public const string HighwayTagKey = "highway";
+    public const string JunctionTagKey = "junction";
+    public const string OneWayTag = "oneway";
+    public const string RoundaboutValue = "roundabout";
+    public const string YesValue = "yes";
+    public const string TrueValue = "true";
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/Way.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/Way.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/Way.cs	(revision 8516)
@@ -0,0 +1,155 @@
+﻿
+using System;
+using System.Collections.Generic;
+namespace HeuristicLab.Problems.RoutePlanning.Data.Osm.Core {
+  #region Highway Types
+
+  // see: https://wiki.openstreetmap.org/wiki/Key:highway
+  public enum HighwayType {
+    null_type,
+    motorway,
+    motorway_link,
+    trunk,
+    trunk_link,
+    primary,
+    primary_link,
+    secondary,
+    secondary_link,
+    tertiary,
+    tertiary_link,
+    living_street,
+    pedestrian,
+    residential,
+    unclassified,
+    service,
+    track,
+    bus_guideway,
+    raceway,
+    road,
+    path,
+    footway,
+    cycleway,
+    bridleway,
+    steps
+  }
+
+  #endregion
+
+  public class Way : OsmBase {
+    private List<Node> nodes;
+
+    public Way() {
+      nodes = new List<Node>();
+    }
+
+    public Way(long id)
+      : base(id) {
+      nodes = new List<Node>();
+    }
+
+    public List<Node> Nodes {
+      get { return nodes; }
+    }
+
+    public HighwayType HighwayTag {
+      get {
+        if (!base.Tags.ContainsKey(TagConstants.HighwayTagKey)) {
+          return HighwayType.null_type;
+        }
+        if (Enum.IsDefined(typeof(HighwayType), base.Tags[TagConstants.HighwayTagKey])) {
+          HighwayType ht = (HighwayType)Enum.Parse(
+            typeof(HighwayType),
+            base.Tags[TagConstants.HighwayTagKey],
+            true);
+          return ht;
+        } else {
+          return HighwayType.null_type;
+        }
+      }
+    }
+
+    public bool OneWay {
+      get {
+        if (base.Tags.ContainsKey(TagConstants.OneWayTag)) {
+          string value = base.Tags[TagConstants.OneWayTag];
+          return value.Equals(TagConstants.YesValue);
+        } else {
+          return false;
+        }
+      }
+    }
+
+    public bool CanBeTraversed(Node source, Node target) {
+      // check if way can be traveld by a specific vehicle (car, public transport, pedestiran, bicycle)
+      // if (!CanBeTraversed(Vehicle)) return false
+      if (OneWay) {
+        // if vehicle == pedestrian or bicylce -> return true
+        int sourceIndex = Nodes.IndexOf(source);
+        int targetIndex = Nodes.IndexOf(target);
+        // order of the nodes determines the driving direction
+        return (sourceIndex < targetIndex);
+      }
+      return true;
+    }
+
+    //public bool CanBeTraversed(Vehicle) {}
+
+    public int GetMaxSpeed() {
+      int speed = 0;
+
+      //TODO: 
+      HighwayType highwayType = HighwayTag;
+      switch (highwayType) {
+        case HighwayType.bridleway:
+        case HighwayType.bus_guideway:
+        case HighwayType.raceway:
+        case HighwayType.cycleway:
+        case HighwayType.footway:
+        case HighwayType.steps:
+        case HighwayType.null_type:
+          speed = 1;
+          break;
+
+        case HighwayType.path:
+        case HighwayType.service:
+        case HighwayType.pedestrian:
+        case HighwayType.living_street:
+          speed = 15;
+          break;
+
+        case HighwayType.road:
+        case HighwayType.track:
+          speed = 30;
+          break;
+
+        case HighwayType.tertiary:
+        case HighwayType.tertiary_link:
+        case HighwayType.secondary:
+        case HighwayType.secondary_link:
+          speed = 80;
+          break;
+
+        case HighwayType.unclassified:
+        case HighwayType.residential:
+          speed = 50;
+          break;
+
+        case HighwayType.trunk:
+        case HighwayType.trunk_link:
+        case HighwayType.primary:
+        case HighwayType.primary_link:
+          speed = 100;
+          break;
+        case HighwayType.motorway:
+        case HighwayType.motorway_link:
+          speed = 130;
+          break;
+
+        default:
+          speed = 1;
+          break;
+      }
+      return speed;
+    }
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm/OsmDataSource.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm/OsmDataSource.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm/OsmDataSource.cs	(revision 8516)
@@ -0,0 +1,221 @@
+﻿using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Xml;
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
+using HeuristicLab.Problems.RoutePlanning.RoutingGraph;
+using HeuristicLab.Problems.RoutePlanning.Data.Osm.Core;
+
+namespace HeuristicLab.Problems.RoutePlanning.Data.Osm {
+  public class OsmDataSource : IDataSource {
+    private FileInfo file;
+    private Dictionary<long, Vertex> vertices;
+    private IGraph graph;
+
+    public OsmDataSource(string filename) {
+      file = new FileInfo(filename);
+      graph = new Graph();
+      vertices = new Dictionary<long, Vertex>();
+
+      ReadData();
+    }
+
+    #region IDataSource Members
+
+    public IGraph GetRoutingGraph() {
+      return graph;
+    }
+
+    #endregion
+
+    private Vertex GetVertex(long Id) {
+      Vertex v;
+      if (vertices.TryGetValue(Id, out v)) {
+        return v;
+      } else {
+        return null;
+      }
+    }
+
+    private void ReadData() {
+      XmlReaderSettings settings = new XmlReaderSettings();
+      settings.IgnoreComments = true;
+      settings.IgnoreWhitespace = true;
+
+      using (XmlReader reader = XmlReader.Create(file.FullName, settings)) {
+        reader.ReadStartElement("osm");
+        //reader.ReadStartElement("bounds");
+        reader.Read();
+        while (reader.LocalName.Equals("node")) {
+          double lat = XmlConvert.ToDouble(reader.GetAttribute("lat"));
+          double lon = XmlConvert.ToDouble(reader.GetAttribute("lon"));
+          long id = XmlConvert.ToInt64(reader.GetAttribute("id"));
+
+          Vertex v = new Vertex(id, lon, lat);
+          vertices.Add(v.Id, v);
+
+          reader.Read();
+          if (reader.LocalName.Equals("tag")) {
+            reader.ReadToFollowing("node");
+          }
+        }
+        while (reader.LocalName.Equals("way")) {
+          List<Vertex> way = new List<Vertex>();
+          bool missingNodes = false;
+          HighwayType category = HighwayType.null_type;
+          bool oneWayRoad = false;
+
+          reader.Read();
+          while (reader.LocalName.Equals("nd") || reader.LocalName.Equals("tag")) {
+            if (reader.LocalName.Equals("nd")) {
+              long refNodeId = XmlConvert.ToInt64(reader.GetAttribute("ref"));
+              Vertex vertex = GetVertex(refNodeId);
+              if (vertex != null) {
+                way.Add(vertex);
+              } else {
+                missingNodes = true;
+              }
+
+            } else if (reader.LocalName.Equals("tag")) {
+              string key = reader.GetAttribute("k");
+              string value = reader.GetAttribute("v");
+
+              if (key == TagConstants.HighwayTagKey) {
+                if (Enum.IsDefined(typeof(HighwayType), value)) {
+                  HighwayType ht = (HighwayType)Enum.Parse(typeof(HighwayType), value, true);
+                  category = ht;
+                } else {
+                  category = HighwayType.null_type;
+                }
+              } else if (key == TagConstants.OneWayTag) {
+                oneWayRoad = value.Equals(TagConstants.YesValue);
+              }
+            }
+            reader.Read();
+          }
+          if (missingNodes) {
+            // TODO: Error/Trace output 
+            // if Way xxx has incomplete nodes. At least one node was missing in the data.
+          }
+          for (int i = 0; i < way.Count - 1; i++) {
+            Vertex v1 = way[i];
+            graph.AddVertex(v1);
+            Vertex v2 = way[i + 1];
+            graph.AddVertex(v2);
+            short vertexCategory = (short)category;
+            if (oneWayRoad) {
+              Edge<Vertex> edge = new Edge<Vertex>(v1, v2, vertexCategory);
+              graph.AddEdge(edge);
+            } else {
+              Edge<Vertex> edgeForward = new Edge<Vertex>(v1, v2, vertexCategory);
+              graph.AddEdge(edgeForward);
+
+              Edge<Vertex> edgeBackward = new Edge<Vertex>(v2, v1, vertexCategory);
+              graph.AddEdge(edgeBackward);
+            }
+          }
+          reader.Read();
+        }
+        reader.Close();
+      }
+    }
+
+    private void ReadDataV2() {
+      XmlReaderSettings settings = new XmlReaderSettings();
+      settings.IgnoreComments = true;
+      settings.IgnoreWhitespace = true;
+      NameTable nt = new NameTable();
+      string osmName = nt.Add("osm");
+      object nodeName = nt.Add("node");
+      object tagName = nt.Add("tag");
+      object wayName = nt.Add("way");
+      string latName = nt.Add("lat");
+      string lonName = nt.Add("lon");
+      string idName = nt.Add("id");
+      object ndName = nt.Add("nd");
+      string refName = nt.Add("ref");
+      string kName = nt.Add("k");
+      string vName = nt.Add("v");
+      settings.NameTable = nt;
+      string ns = "";
+
+      using (XmlReader reader = XmlReader.Create(file.FullName, settings)) {
+        reader.ReadStartElement(osmName, ns);
+        reader.Read();
+        while (reader.LocalName.Equals(nodeName)) {
+          double lat = XmlConvert.ToDouble(reader.GetAttribute(latName, ns));
+          double lon = XmlConvert.ToDouble(reader.GetAttribute(lonName, ns));
+          long id = XmlConvert.ToInt64(reader.GetAttribute(idName, ns));
+
+          Vertex v = new Vertex(id, lon, lat);
+          vertices.Add(v.Id, v);
+
+          reader.Read();
+          //if (reader.LocalName.Equals(tagName)) {
+          if (ReferenceEquals(tagName, reader.LocalName)) {
+            reader.ReadToFollowing((string)nodeName, ns);
+          }
+        }
+        //while (reader.LocalName.Equals(wayName)) {
+        while (ReferenceEquals(wayName, reader.LocalName)) {
+          List<Vertex> way = new List<Vertex>();
+          bool missingNodes = false;
+          HighwayType category = HighwayType.null_type;
+          bool oneWayRoad = false;
+
+          reader.Read();
+          while (ReferenceEquals(ndName, reader.LocalName) || ReferenceEquals(tagName, reader.LocalName)) {
+            if (reader.LocalName.Equals(ndName)) {
+              long refNodeId = XmlConvert.ToInt64(reader.GetAttribute(refName, ns));
+              Vertex vertex = GetVertex(refNodeId);
+              if (vertex != null) {
+                way.Add(vertex);
+              } else {
+                missingNodes = true;
+              }
+
+            } else if (reader.LocalName.Equals(tagName)) {
+              string key = reader.GetAttribute(kName, ns);
+              string value = reader.GetAttribute(vName, ns);
+
+              if (key == TagConstants.HighwayTagKey) {
+                if (Enum.IsDefined(typeof(HighwayType), value)) {
+                  HighwayType ht = (HighwayType)Enum.Parse(typeof(HighwayType), value, true);
+                  category = ht;
+                } else {
+                  category = HighwayType.null_type;
+                }
+              } else if (key == TagConstants.OneWayTag) {
+                oneWayRoad = value.Equals(TagConstants.YesValue);
+              }
+            }
+            reader.Read();
+          }
+          if (missingNodes) {
+            // TODO: Error/Trace output 
+            // if Way xxx has incomplete nodes. At least one node was missing in the data.
+          }
+          for (int i = 0; i < way.Count - 1; i++) {
+            Vertex v1 = way[i];
+            graph.AddVertex(v1);
+            Vertex v2 = way[i + 1];
+            graph.AddVertex(v2);
+            short vertexCategory = (short)category;
+            if (oneWayRoad) {
+              Edge<Vertex> edge = new Edge<Vertex>(v1, v2, vertexCategory);
+              graph.AddEdge(edge);
+            } else {
+              Edge<Vertex> edgeForward = new Edge<Vertex>(v1, v2, vertexCategory);
+              graph.AddEdge(edgeForward);
+
+              Edge<Vertex> edgeBackward = new Edge<Vertex>(v2, v1, vertexCategory);
+              graph.AddEdge(edgeBackward);
+            }
+          }
+          reader.Read();
+        }
+        reader.Close();
+      }
+    }
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/HeuristicLab.Problems.RoutePlanning.csproj
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/HeuristicLab.Problems.RoutePlanning.csproj	(revision 8515)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/HeuristicLab.Problems.RoutePlanning.csproj	(revision 8516)
@@ -57,28 +57,24 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="DIMACS\DIMACSDataSource.cs" />
-    <Compile Include="Graph\EarthDistanceCostCalculator.cs" />
-    <Compile Include="Graph\ICostCalculator.cs" />
-    <Compile Include="Graph\Edge.cs" />
-    <Compile Include="Graph\Graph.cs" />
-    <Compile Include="Graph\IGraph.cs" />
-    <Compile Include="Graph\OsmGraph.cs" />
-    <Compile Include="Graph\IEdge.cs" />
-    <Compile Include="Graph\OsmVertex.cs" />
-    <Compile Include="Graph\Route.cs" />
-    <Compile Include="Graph\TravelTimeCostCalculator.cs" />
-    <Compile Include="Graph\Vertex.cs" />
-    <Compile Include="Osm.Data\OsmDataSource.cs" />
-    <Compile Include="Osm.Data\XmlDataSource.cs" />
-    <Compile Include="Osm\IDataSource.cs" />
-    <Compile Include="Osm\Node.cs" />
-    <Compile Include="Osm\OsmBase.cs" />
-    <Compile Include="Osm\PointD.cs" />
-    <Compile Include="Osm\RectangleD.cs" />
-    <Compile Include="Osm\Relation.cs" />
-    <Compile Include="Osm\RelationMember.cs" />
-    <Compile Include="Osm\TagConstants.cs" />
-    <Compile Include="Osm\Utils.cs" />
-    <Compile Include="Osm\Way.cs" />
+    <Compile Include="Data.DIMACS\DIMACSDataSource.cs" />
+    <Compile Include="RoutingGraph\EarthDistanceCostCalculator.cs" />
+    <Compile Include="Interfaces\ICostCalculator.cs" />
+    <Compile Include="RoutingGraph\Edge.cs" />
+    <Compile Include="RoutingGraph\Graph.cs" />
+    <Compile Include="Interfaces\IGraph.cs" />
+    <Compile Include="Interfaces\IEdge.cs" />
+    <Compile Include="RoutingGraph\TravelTimeCostCalculator.cs" />
+    <Compile Include="RoutingGraph\Vertex.cs" />
+    <Compile Include="Data.Osm\OsmDataSource.cs" />
+    <Compile Include="Interfaces\IDataSource.cs" />
+    <Compile Include="Data.Osm.Core\Node.cs" />
+    <Compile Include="Data.Osm.Core\OsmBase.cs" />
+    <Compile Include="Utilities\PointD.cs" />
+    <Compile Include="Utilities\RectangleD.cs" />
+    <Compile Include="Data.Osm.Core\Relation.cs" />
+    <Compile Include="Data.Osm.Core\RelationMember.cs" />
+    <Compile Include="Data.Osm.Core\TagConstants.cs" />
+    <Compile Include="Utilities\Utils.cs" />
+    <Compile Include="Data.Osm.Core\Way.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
@@ -90,4 +86,5 @@
     <None Include="Properties\AssemblyInfo.cs.frame" />
   </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/ICostCalculator.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/ICostCalculator.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/ICostCalculator.cs	(revision 8516)
@@ -0,0 +1,8 @@
+﻿
+using HeuristicLab.Problems.RoutePlanning.RoutingGraph;
+namespace HeuristicLab.Problems.RoutePlanning.Interfaces {
+  public interface ICostCalculator {
+    float Costs(Edge<Vertex> edge);
+    float EstimatedCosts(Vertex source, Vertex destination);
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/IDataSource.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/IDataSource.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/IDataSource.cs	(revision 8516)
@@ -0,0 +1,6 @@
+﻿
+namespace HeuristicLab.Problems.RoutePlanning.Interfaces {
+  public interface IDataSource {
+    IGraph GetRoutingGraph();
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/IEdge.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/IEdge.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/IEdge.cs	(revision 8516)
@@ -0,0 +1,7 @@
+﻿
+namespace HeuristicLab.Problems.RoutePlanning.Interfaces {
+  public interface IEdge<T> {
+    T Source { get; }
+    T Target { get; }
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/IGraph.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/IGraph.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Interfaces/IGraph.cs	(revision 8516)
@@ -0,0 +1,24 @@
+﻿
+using System.Collections.Generic;
+using HeuristicLab.Problems.RoutePlanning.RoutingGraph;
+namespace HeuristicLab.Problems.RoutePlanning.Interfaces {
+  public interface IGraph {
+    void AddVertex(Vertex vertex);
+    Vertex GetVertex(long id);
+    List<Vertex> GetVertices();
+    void AddEdge(long startId, long endId);
+    void AddEdge(Edge<Vertex> edge);
+    void RemoveEdge(long startId, long endId);
+    bool HasEdge(long startId, long endId);
+    Edge<Vertex> GetEdge(long startId, long endId);
+    List<Edge<Vertex>> GetEdges(long vertexId);
+    List<Edge<Vertex>> GetInEdges(long vertexId);
+    List<Edge<Vertex>> GetOutEdges(long vertexId);
+    Dictionary<long, float> GetNeighborsWithWeight(long id);
+    Dictionary<long, float> GetNeighborsWithWeightReversed(long id);
+    int GetOutDegree(long id);
+    int GetInDegree(long id);
+
+    float EstimatedCosts(long sourceId, long targetId);
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutePlanningProblem.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutePlanningProblem.cs	(revision 8515)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutePlanningProblem.cs	(revision 8516)
@@ -27,7 +27,6 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Problems.RoutePlanning.Graph;
-using HeuristicLab.Problems.RoutePlanning.Osm;
-using HeuristicLab.Problems.RoutePlanning.Osm.Data;
+using HeuristicLab.Problems.RoutePlanning.Data.Osm;
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
 
 namespace HeuristicLab.Problems.RoutePlanning {
@@ -42,5 +41,5 @@
 
     IDataSource dataSource;
-    OsmGraph graph;
+    IGraph graph;
 
     #region Parameter Properties
@@ -105,6 +104,6 @@
     public void LoadData(string file) {
       FileInfo f = new FileInfo(file);
-      dataSource = new XmlDataSource(file);
-      graph = new OsmGraph(dataSource);
+      dataSource = new OsmDataSource(file);
+      graph = dataSource.GetRoutingGraph();
 
       Name = f.Name;
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/EarthDistanceCostCalculator.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/EarthDistanceCostCalculator.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/EarthDistanceCostCalculator.cs	(revision 8516)
@@ -0,0 +1,40 @@
+﻿using System;
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
+
+namespace HeuristicLab.Problems.RoutePlanning.RoutingGraph {
+  public class EarthDistanceCostCalculator : ICostCalculator {
+    private const double earthMeanRadius = 6371.0 * 1000.0;
+
+    #region ICostCalculator Members
+
+    public float Costs(Edge<Vertex> edge) {
+      return edge.Weight;
+    }
+
+    public float EstimatedCosts(Vertex source, Vertex destination) {
+      return (float)EarthDistance(source.Logitude, source.Latitude, destination.Logitude, destination.Latitude);
+    }
+
+    #endregion
+
+    private double DegToRad(double alpha) {
+      return alpha * Math.PI / 180;
+    }
+
+    private double AngularDistance(double startLon, double startLat, double endLon, double endLat) {
+      double lat1 = DegToRad(startLat);
+      double lat2 = DegToRad(endLat);
+      double long1 = DegToRad(startLon);
+      double long2 = DegToRad(endLat);
+
+      double x = Math.Sin(lat1) * Math.Sin(lat2) + Math.Cos(lat1) * Math.Cos(lat2) * Math.Cos(long1 - long2);
+      x = Math.Min(1, Math.Max(0, x));
+
+      return Math.Acos(x);
+    }
+
+    private double EarthDistance(double startLon, double startLat, double endLon, double endLat) {
+      return earthMeanRadius * AngularDistance(startLon, startLat, endLon, endLat);
+    }
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/Edge.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/Edge.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/Edge.cs	(revision 8516)
@@ -0,0 +1,112 @@
+﻿
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
+namespace HeuristicLab.Problems.RoutePlanning.RoutingGraph {
+  public class Edge<Vertex> : IEdge<Vertex> {
+    private readonly Vertex source;
+    public Vertex Source {
+      get { return this.source; }
+    }
+
+    private readonly Vertex target;
+    public Vertex Target {
+      get { return this.target; }
+    }
+
+    private short category;
+    public short Category {
+      get { return category; }
+      set { category = value; }
+    }
+
+    private float weight;
+    public float Weight {
+      get { return weight; }
+      set { weight = value; }
+    }
+
+    public Edge(Vertex source, Vertex target)
+      : this(source, target, 0) {
+
+    }
+
+    public Edge(Vertex source, Vertex target, short category) {
+      this.source = source;
+      this.target = target;
+      this.category = category;
+    }
+
+    public override string ToString() {
+      return string.Format("{0}->{1}", this.Source, this.Target);
+    }
+
+    public override bool Equals(object obj) {
+      if (obj is Edge<Vertex>) {
+        Edge<Vertex> e = (obj as Edge<Vertex>);
+        return (this.source.Equals(e.source)) && (this.target.Equals(e.target));
+      }
+      return false;
+    }
+
+    public override int GetHashCode() {
+      return source.GetHashCode() ^ target.GetHashCode();
+    }
+
+    public int GetMaxSpeed() {
+      int speed = 0;
+
+      //TODO: 
+      switch (category) {
+        case 23:
+        case 17:
+        case 18:
+        case 22:
+        case 21:
+        case 24:
+        case 16:
+        case 20:
+        case 15:
+        case 12:
+        case 0:
+          speed = 1;
+          break;
+
+        case 11:
+        case 14:
+          speed = 15;
+          break;
+
+        case 19:
+          speed = 30;
+          break;
+
+        case 9:
+        case 10:
+        case 7:
+        case 8:
+          speed = 80;
+          break;
+
+        case 13:
+          speed = 50;
+          break;
+
+        case 3:
+        case 4:
+        case 5:
+        case 6:
+          speed = 100;
+          break;
+
+        case 1:
+        case 2:
+          speed = 130;
+          break;
+
+        default:
+          speed = 1;
+          break;
+      }
+      return speed;
+    }
+  }
+}
